.nolist	; copied from icztutes\tute09, with [url=+0]small changes[/url]
include \masm32\include\masm32rt.inc

WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName	db "SimpleWinClass", 0
AppName	db "Our First Window", 0

.data?
hInstance	HINSTANCE ?
hEdit	HWND ?
hStatic	HWND ?
buffer	dd 128 dup(?)

idEdit	equ 100
idStatic	equ 101

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke WinMain, hInstance, NULL, 0, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	and wc.lpszMenuName, 0
	mov wc.lpszClassName, OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName, addr AppName, 
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 
		CW_USEDEFAULT, 118, 80, NULL, NULL, 
	hInst, NULL
	mov hwnd, eax
;	invoke RegisterHotKey, eax, 111, 0, VK_LWIN
	.if eax
		.While TRUE
			invoke GetMessage, addr msg, NULL, 0, 0
			.Break .If !eax
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.ENDW
		mov eax, msg.wParam
	.else
		MsgBox 0, "RegisterHotKey failed", "Hi", MB_OK
	.endif
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.If uMsg==WM_CREATE
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
		WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL,
		3, 3, 99, 25, hWnd, idEdit, hInstance, NULL
		mov hEdit, eax

		invoke CreateWindowEx, NULL, chr$("static"), 0,
			WS_CHILD or WS_VISIBLE or ES_LEFT,
			3, 30, 99, 25,
			hWnd, idStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created

		invoke SendMessage, hStatic, WM_SETFONT, rv(GetStockObject, ANSI_VAR_FONT), 1		; give it the small font

		invoke SetTimer, hWnd, 123, 1, 0
		invoke SendMessage, hWnd, WM_SETHOTKEY, VK_LWIN, 0
		.if eax!=1
			MsgBox 0, str$(eax), "Hotkey failed", MB_OK
		.endif

	.ElseIf uMsg==WM_HOTKEY
		MsgBox 0, "Gotcha WM_HOTKEY", "Hi", MB_OK

	.ElseIf uMsg==WM_SYSCOMMAND
		.if wParam==SC_HOTKEY
			MsgBox 0, "Gotcha WM_SYSCOMMAND", "Hi", MB_OK
		.endif

	.ElseIf uMsg==WM_TIMER
		invoke GetAsyncKeyState, VK_LWIN
		.if sword ptr ax<0
			.Repeat
				invoke GetAsyncKeyState, VK_LWIN	; while win key is pressed
				.Break .if sword ptr ax>=0
				invoke GetAsyncKeyState, VK_S		; wait for S
			.Until sword ptr ax<0
			.if sword ptr ax<0
				if 0
					invoke SetForegroundWindow, hWnd	; won't work properly
				else
					invoke KillTimer, hWnd, 123
					invoke ShowWindow, hWnd, SW_HIDE
					invoke ShowWindow, hWnd, SW_MINIMIZE
					invoke ShowWindow, hWnd, SW_RESTORE
				endif
				invoke SetFocus, hEdit
			.endif
		.endif

	.ElseIf uMsg==WM_COMMAND
		movzx eax, word ptr wParam
		.If eax==idEdit
			invoke GetWindowText, hEdit, addr buffer, 512
			.if eax>=2
				invoke SetWindowText, hStatic, addr buffer
				invoke SetWindowText, hEdit, 0
				invoke ShowWindow, hWnd, SW_HIDE
				; .... copy buffer to clipboard .....
				invoke SetTimer, hWnd, 123, 1, 0
			.else
				invoke SetWindowText, hStatic, chr$("Type two chars")
			.endif
		.Endif

	.ElseIf uMsg==WM_DESTROY
		invoke PostQuitMessage, NULL

	.Endif

	invoke DefWindowProc, hWnd, uMsg, wParam, lParam	; moved down here, different from icztutes\tute09
	ret
WndProc endp
end start

RichMasm options:
OPT_Icon Smiley			; see \Masm32\RichMasm\Icons
OPT_Tmp2Asm	1
